C $Id: chi2g.for,v 1.2 2002/08/16 15:13:22 amodigli Exp $
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)chi2g.for	1.0 (ESO-DFS) 23/10/01 12:26:19
C derived from necopt.prg
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  21:13 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR : M Peron, S. Wolf, A. Modigliani
C
C.IDENTIFICATION
C  program  ECHOPT  version 1.0 011023 
C
C.KEYWORDS
C
C  ECHELLE, CASPEC, DATA EXTRACTION
C
C.PURPOSE
C see Role below
C
C.SYNTAX
C
C.HISTORY:
C  2001.10.23-AM created
C
C***************************************************************************
C------------------------------------------------------------------------------
C $Name:  $
C $Revision: 1.2 $
C $Log: chi2g.for,v $
C Revision 1.2  2002/08/16 15:13:22  amodigli
C Speed-up
C
C Revision 1.1  2001/11/01 07:18:36  amodigli
C First version of necopt with splitted data
C
C------------------------------------------------------------------------------
C  who    when           why                               where
C  AM     23/10/01       created                           all
C------------------------------------------------------------------------------
C  Role: evaluates chi-square between points and the found gaussian 
C        distribution
C------------------------------------------------------------------------------

      FUNCTION CHI2G(AMP, PR, FBVAL, VAR, MASK, BKG, NPIXA1, DIM, INDX)
      
      IMPLICIT NONE
      INTEGER NPIXA1               !X dimension of mask ima
      INTEGER DIM                  !Y dimension of mask ima
      INTEGER INDX                 !current X position of x-order profile
      INTEGER*2 MASK(NPIXA1,DIM)   !array with mask ima

      REAL AMP                     !Gaussian amplitide
      REAL PR(DIM)                 !Gaussian profile
      REAL FBVAL(NPIXA1,DIM)       !Raw ima points
      REAL VAR(DIM)                !Variance ima
      REAL BKG                     !constant term in Gaussian+linear

C
C     Local variables
C
      INTEGER I                    !index for loop
      REAL CHI2G                   !tmp value of Gaussian chi-square
      REAL ARG                     !tmp arg

      CHI2G = 0.
      DO I = 1, DIM
         IF (MASK(INDX,I).GT.0) THEN
            ARG=(AMP*PR(I)+BKG-FBVAL(INDX,I))
            CHI2G = CHI2G + ARG*ARG/VAR(I)
         ENDIF
      END DO
      RETURN
      END

C ===========================================================================

