C $Id: dchi1.for,v 1.1 2001/11/01 07:18:37 amodigli Exp $
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)dchi1.for	2.4 (ESO-DFS) 23/10/01 12:26:19
C derived from necopt.for
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  21:13 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR : M Peron, S. Wolf, A. Modigliani
C
C.IDENTIFICATION
C  program  ECHOPT  version 1.0 011023 
C
C.KEYWORDS
C
C  ECHELLE, CASPEC, DATA EXTRACTION
C
C.PURPOSE
C evaluates CHI2G-CHI2MIN -1
C
C.SYNTAX
C
C.HISTORY:
C  2001.10.23-AM Created 
C
C***************************************************************************
C------------------------------------------------------------------------------
C $Name:  $
C $Revision: 1.1 $
C $Log: dchi1.for,v $
C Revision 1.1  2001/11/01 07:18:37  amodigli
C First version of necopt with splitted data
C
C
C------------------------------------------------------------------------------
C------------------------------------------------------------------------------
C  who    when           why                               where
C  AM     23/10/01       clean-comment                     DCHI1
C------------------------------------------------------------------------------
C  Role: evaluates CHI2G-CHI2MIN -1
C------------------------------------------------------------------------------
      FUNCTION DCHI1(AMP,PR,FBVAL,VAR,MASK,A,NPIXA1,DIM,CHI2MIN,INDX)

      IMPLICIT NONE

      INTEGER NPIXA1             !X dimension of mask
      INTEGER DIM                !Y dimension of mask
      INTEGER INDX               !current X position of x-order profile
      INTEGER*2 MASK(NPIXA1,DIM) !Array to hold mask image

      REAL AMP                   !Gaussian amplitude
      REAL PR(DIM)               !Gaussian profile points
      REAL FBVAL(NPIXA1,DIM)     !Ray ima points
      REAL VAR(DIM)              !variance image
      REAL BKG                   !constant value of gaussian + linear
      REAL A(10)                 !coeffs of x-order (Gaussian+linear) profile
      
C
C     Local variables
C
      REAL CHI2G                 !chi2 of gaussian relative to x-order profile
      REAL CHI2MIN               !chi-square minimum
      REAL DD                    !temporary value of chi-square
      REAL DCHI1                 !result

      EXTERNAL CHI2G             !chi2 for Gaussian profile

      BKG = (A(5)-A(2)*AMP)/A(4)
      DD    = CHI2G(AMP, PR, FBVAL, VAR, MASK, BKG, NPIXA1, DIM, INDX)
      DCHI1 = DD - CHI2MIN - 1.0


      RETURN
      END

C ================================================================================
