C $Id: dmpqc1.for,v 1.7 2002/08/16 15:14:32 amodigli Exp $
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)dmpqc1.for	1.0 (ESO-IPG) 23/10/01 12:26:19
C+
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  21:13 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR : M Peron, S. Wolf, A. Modigliani
C
C.IDENTIFICATION
C  program  ECHOPT  version 1.0 011023 
C
C.KEYWORDS
C
C  ECHELLE, CASPEC, DATA EXTRACTION
C
C.PURPOSE
C Dump QC1 info on a table.
C
C.SYNTAX
C
C.HISTORY:
C  2001.10.23-AM Created
C
C***************************************************************************
C------------------------------------------------------------------------------
C $Name:  $
C $Revision: 1.7 $
C $Log: dmpqc1.for,v $
C Revision 1.7  2002/08/16 15:14:32  amodigli
C Initialize some var
C
C Revision 1.6  2002/02/11 09:53:15  amodigli
C decreased size of descriptors
C
C Revision 1.5  2002/02/03 07:56:40  amodigli
C Eliminated ftnchk waring: declared MADRID as INTEGER
C
C Revision 1.4  2002/02/03 07:51:23  amodigli
C Eliminated I_FILE 1st argument as unnecessary
C
C Revision 1.3  2002/02/02 16:46:44  amodigli
C Simplified as suggested from Klaus
C
C Revision 1.2  2001/11/01 09:30:17  amodigli
C Eliminated several warnings from ftnchek
C
C Revision 1.1  2001/11/01 07:18:36  amodigli
C First version of necopt with splitted data
C
C------------------------------------------------------------------------------
C  who    when           why                               where
C  AM     23/10/01       Created                           all
C  AM     16/08/02       initialize var                    all
C==================================================================================                    
C==================================================================================
C=====SUBROUTINE TO DUMP QC1 LOG===================================================
C==================================================================================      
      
      SUBROUTINE DMPQC1(FIDNO,MID_S_N_CENT,OBJ_POS_CENT,
     +                  FWHM,N_CURR_ORD)
 
      IMPLICIT NONE

C     Interface variables         
      INTEGER N_CURR_ORD              !Variable to store current order number
      INTEGER FIDNO                   !File Identification Number                              
      REAL MID_S_N_CENT               !Average S/N     at order center
      REAL OBJ_POS_CENT               !Average OBJ pos at order center
      REAL FWHM                       !Average FWHM    at order center           
      
       
C     Local variables
      INTEGER I_SIZE                  !Aux. variable to do string manipulation
      INTEGER DUN                     !Units (MIDAS env int.)  
 
      INTEGER IS                  !Status of operation (MIDAS env int.) 
      INTEGER VARLEN                  !variable length of VARNAME (1 or 2)  
      INTEGER MADRID                  !Memory Addres Identification
      
      CHARACTER*2  VARNAME            !buffer for information
      CHARACTER*20 DES_QC             !FITS base key for information
      CHARACTER*30 DESQCNM            !FITS key for information
      CHARACTER*28 INFO_BUFFER        !buffer for information

      INCLUDE 'MID_INCLUDE:ST_DEF.INC'   !to get the definitions 
                                         !on the ST interfaces
      COMMON /VMR/MADRID(1)              !COMMON block for the 
                                         !pointer emulation in F77
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'   !to get data values for 
                                         !definitions above
                                          
C     Initializes all int variables to 0 to be sure...
      I_SIZE      =0 
      DUN         =0
      IS          =0
      VARLEN      =0

C     Initializes all char variables to null string to be sure...
 
      INFO_BUFFER(1:) = ' '
      VARNAME(1:) = ' '
      DESQCNM(1:) = ' '
      DES_QC(1:) = ' '
      
C     Now print out the QC parameters as different descriptor names       
      DES_QC='ESO.QC.OBJ'
                                                 
      DUN=0   

      IF (N_CURR_ORD .LE. 9) THEN
         WRITE(VARNAME,1000) N_CURR_ORD
         VARLEN=1
      ELSE
         WRITE(VARNAME,2000) N_CURR_ORD
         VARLEN=2
      ENDIF
      
      I_SIZE = MAX(INDEX(DES_QC,' ')-1,1)
      DESQCNM=DES_QC(1:I_SIZE)//VARNAME(1:VARLEN)//'.SN'
      CALL STDWRR(FIDNO,DESQCNM,MID_S_N_CENT,1,1,DUN,IS)
      INFO_BUFFER(1:24)='Av. S/N at order center '
      CALL STDWRH(FIDNO,DESQCNM,INFO_BUFFER,1,23,IS)

      I_SIZE = MAX(INDEX(DES_QC,' ')-1,1)
      DESQCNM=DES_QC(1:I_SIZE)//VARNAME(1:VARLEN)//'.FWHM'
      CALL STDWRR(FIDNO,DESQCNM,FWHM,1,1,DUN,IS)
      INFO_BUFFER(1:18)='Av. FWHM on order '
      CALL STDWRH(FIDNO,DESQCNM,INFO_BUFFER,1,17,IS)
  
      I_SIZE = MAX(INDEX(DES_QC,' ')-1,1)
      DESQCNM=DES_QC(1:I_SIZE)//VARNAME(1:VARLEN)//'.POS'
      CALL STDWRR(FIDNO,DESQCNM,OBJ_POS_CENT,1,1,DUN,IS)
      INFO_BUFFER(1:28)='Av. OBJ POS at order center '  
      CALL STDWRH(FIDNO,DESQCNM,INFO_BUFFER,1,27,IS)
                                                   
 1000 FORMAT(I1)
 2000 FORMAT(I2)
      RETURN
      END
      
C ================================================================================
