C $Id: getqci.for,v 1.5 2002/08/16 15:15:59 amodigli Exp $
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)get_qc_info.for	2.4 (ESO-IPG) 12/6/91 12:26:19
C+
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  21:13 - 2 NOV 2001
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR : Modigliani
C
C.IDENTIFICATION
C  subroutine  getqci  version 1.0 011102 
C
C.KEYWORDS
C
C  ECHELLE, CASPEC, DATA EXTRACTION
C
C.PURPOSE
C To get approximate average OBJ POS, S/N, FWHM at order center
C
C.SYNTAX
C
C.HISTORY:
C  2001.11.02-AM Created. Derived from necopt.for
C
C***************************************************************************
C------------------------------------------------------------------------------
C $Name:  $
C $Revision: 1.5 $
C $Log: getqci.for,v $
C Revision 1.5  2002/08/16 15:15:59  amodigli
C init some variable
C
C Revision 1.4  2002/05/30 06:09:11  amodigli
C Corrected some errors in OUT,VOUT,FWHM,S/N
C originally due to not to have properly taken
C a normlaized FGAUS function.
C
C Revision 1.3  2002/02/03 08:30:21  amodigli
C declared N_CURR_ORD
C
C Revision 1.2  2002/02/03 08:25:28  amodigli
C Eliminated several warnings from ftnchk
C
C Revision 1.1  2001/11/09 18:01:41  amodigli
C Created extra modules as part of DFS
C code rev step 2
C
C==============================================================================
C------------------------------------------------------------------------------
C  who    when           why                               where
C  AM     02/11/01       create                            all (getqci)
C  AM     16/08/02       init some variable                all
C------------------------------------------------------------------------------
C  Role: evaluates average OBJ POS, S/N, FWHM at order center
C------------------------------------------------------------------------------
C*******************************************************************
C********************SUBROUTINE*************************************
C*******************************************************************
      SUBROUTINE GETQCI(IXMIN,IXMAX,PBUF,PDIM,NPIXA1,FBVAL,DIM,CONAD)
     
      IMPLICIT NONE
      INTEGER NPOINT                     !no of points over which we do an average
      INTEGER N_MAX_ORD                  !maximum number of orders
      PARAMETER(NPOINT=101,N_MAX_ORD=50)
C Interface variables
     
      INTEGER IXMIN
      INTEGER IXMAX
      INTEGER PDIM                       !X dimension of mask
      INTEGER NPIXA1                     !X size of mask 
      INTEGER DIM                        !Y dimension of mask
                        
      REAL PBUF(PDIM,NPIXA1)             !buffer for coefficients of profile
      REAL FBVAL(NPIXA1,DIM)             !raw ima
      REAL CONAD                         !Analog To Digital conversion factor
C     Common variables
      INTEGER N_CURR_ORD                 !current order no
      REAL MID_S_N_CENT(N_MAX_ORD)       !tmp S/N value
      REAL OBJ_POS_CENT(N_MAX_ORD)       !tmp obj position
      REAL FWHM(N_MAX_ORD)               !tmp array to hold average FWHM
                                       
C     Local variables     
      INTEGER IXCENTRAL
      INTEGER I_SIZ_CENT
      INTEGER K
      INTEGER L  
      INTEGER INDEX                       !auxilliary variable
      INTEGER STATUS                  !Status of operation (MIDAS env int.)
      INTEGER MADRID                     !(MIDAS env) Memory address id

      REAL AV_SIGNAL
      REAL SIGNAL(NPOINT)                !tmp array holder of signal at 
                                         !center of order    
      REAL EPOS                          !error in position determination  
      CHARACTER*72 LINE                  !Buffer to display messanges
      
 
 
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'   !to get the definitions 
                                         !on the ST interfaces
      INCLUDE '../incl/common_qc_log.inc'
      COMMON /VMR/MADRID(1)              !COMMON block for the 
                                         !pointer emulation in F77
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'   !to get data values for 
                                         !definitions above
C     Initializes local variables

C     Integers
      IXCENTRAL = 0
      I_SIZ_CENT = 0
      K = 0
      L = 0
      INDEX = 0
      STATUS = 0

C     Reals
      AV_SIGNAL = 0.
      EPOS = 0.
      DO K=1,NPOINT
         SIGNAL(NPOINT)=0.
      ENDDO
 
C     Chars
      LINE(1:)=' '
 
      
      IXCENTRAL = INT((IXMAX+IXMIN)/2)
      I_SIZ_CENT=25    !half size of the box 
                       !over which calculates medium S/N
                       
      IF ( ((IXCENTRAL-I_SIZ_CENT) .LE. IXMIN) .OR.
     +     ((IXCENTRAL+I_SIZ_CENT) .GE. IXMAX) )  THEN 
           I_SIZ_CENT = MAX(MIN((IXCENTRAL-IXMIN),
     +                          (IXMAX-IXCENTRAL))-1,0)
      ENDIF
  
       
      OBJ_POS_CENT(N_CURR_ORD)=0       !initialize to zero
      FWHM(N_CURR_ORD)=0               !initialize to zero
      DO k =  IXCENTRAL-I_SIZ_CENT,IXCENTRAL+I_SIZ_CENT
 

          OBJ_POS_CENT(N_CURR_ORD)=OBJ_POS_CENT(N_CURR_ORD)+PBUF(2,k)
CAK2002-05-23:   with out FGAUSS (missing a factor 2 in the exponent)
CAK              we have FWHM: W = A(3)*2*sqrt(ln(2))=A(3)*1.66510922232   
CWAS        FWHM(N_CURR_ORD)=FWHM(N_CURR_ORD)+PBUF(3,k) 
         FWHM(N_CURR_ORD)=FWHM(N_CURR_ORD)+PBUF(3,k)*1.66510922232 
      ENDDO  
      
      OBJ_POS_CENT(N_CURR_ORD)=OBJ_POS_CENT(N_CURR_ORD)/(2*I_SIZ_CENT+1)
      FWHM(N_CURR_ORD)=FWHM(N_CURR_ORD)/(2*I_SIZ_CENT+1)
                                        
      AV_SIGNAL=0
      
      
      DO k =  IXCENTRAL-I_SIZ_CENT,IXCENTRAL+I_SIZ_CENT
         INDEX=k-IXCENTRAL+I_SIZ_CENT+1
         SIGNAL(INDEX)=0
         DO l = 1,DIM
            SIGNAL(INDEX)=SIGNAL(INDEX)+FBVAL(k,l)
         ENDDO
         AV_SIGNAL=AV_SIGNAL+SIGNAL(INDEX)
      ENDDO
 
      AV_SIGNAL=MAX(AV_SIGNAL,0.001) !In case bk too high
      AV_SIGNAL=AV_SIGNAL/(2*I_SIZ_CENT+1)
      EPOS=0
      DO k =  1,2*I_SIZ_CENT+1
         EPOS=EPOS+(SIGNAL(k)-AV_SIGNAL)*(SIGNAL(k)-AV_SIGNAL)
      ENDDO
      EPOS=sqrt(EPOS/(2*I_SIZ_CENT))
 
CAK2002-05-23:
CAK       The following is wrong because S/N=sqrt(signal in electrons)...
CAK       the fwhm is only neded if the signal is computed from the Gaussian
CAK       width and height)
CAK
CWAS      MID_S_N_CENT(N_CURR_ORD)=
CWAS     +  sqrt(AV_SIGNAL*FWHM(N_CURR_ORD)*CONAD*2.5066283)
CAK
CAK: the correct is:
CAK       MID_S_N_CENT(N_CURR_ORD)=sqrt(AV_SIGNAL*CONAD)
CAM: but we prefer to calculate the same quantity on the signal-sky=object only
CAK2002-05-23:
CAK let's compute the S/N of the object (without sky) from the
CAK final gaussian (this overwrites the values computed above)
CAK S/N = swrt(conad*a1*a3*sqrt(pi))
      
      MID_S_N_CENT(N_CURR_ORD)=0  !Initializes to zero
      DO k =  IXCENTRAL-I_SIZ_CENT,IXCENTRAL+I_SIZ_CENT
         MID_S_N_CENT(N_CURR_ORD)=MID_S_N_CENT(N_CURR_ORD)+
     .                            CONAD*PBUF(1,k)*PBUF(3,k)*1.77245
      ENDDO
      MID_S_N_CENT(N_CURR_ORD)=MID_S_N_CENT(N_CURR_ORD)/(2*I_SIZ_CENT+1)
      MID_S_N_CENT(N_CURR_ORD)=sqrt(MID_S_N_CENT(N_CURR_ORD))
             
      WRITE(LINE,100) 'Order number : ',N_CURR_ORD
     .               ,' S/N : ',MID_S_N_CENT(N_CURR_ORD)
     .               ,' FWHM : ',FWHM(N_CURR_ORD)     
     +               ,' Obj Pos : ',OBJ_POS_CENT(N_CURR_ORD)
     
      CALL STTPUT(LINE,STATUS)  !display text and store it
                                !in MIDAS log file  
 100  FORMAT(A,I2,A, F8.2, A, F6.2,A, F6.2)     
      RETURN
      END
C=========================================================================     


