C $Id: qcotr0.for,v 1.4 2002/08/16 15:20:01 amodigli Exp $
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)echopt.for	2.4 (ESO-IPG) 12/6/91 12:26:19
C+
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  21:13 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR : A. Modigliani
C
C.IDENTIFICATION
C  program  derived from ECHOPT  version 1.0 011109 
C
C.KEYWORDS
C
C  ECHELLE, CASPEC, DATA EXTRACTION
C
C.PURPOSE
C Dump info on a QC Table
C
C.SYNTAX
C   EXTRACT/ORDER input output  width,ord1,ord2 ron,g,sigma table coeffs
C
C.HISTORY:
C  2001.11.09-AM  Created from necopt.for 
C
C***************************************************************************
C------------------------------------------------------------------------------
C $Name:  $
C $Revision: 1.4 $
C $Log: qcotr0.for,v $
C Revision 1.4  2002/08/16 15:20:01  amodigli
C speed-up
C
C Revision 1.3  2002/02/07 15:49:58  amodigli
C Eliminated check of status as MIDAS keep
C this info on the stack
C
C Revision 1.2  2002/02/03 08:44:26  amodigli
C Added MADRID declaration to reduce ftnchk
C warnings
C
C Revision 1.1  2001/11/09 18:01:51  amodigli
C Created extra modules as part of DFS
C code rev step 2
C
C
C------------------------------------------------------------------------------
C  who    when           why                               where
C  AM     15/07/01       Created from necopt.for           all
C  AM     16/08/02       speed-up                          all
C------------------------------------------------------------------------------
    
      SUBROUTINE QCOTR0(I1,XSTP,IXMIN,NUM,PBUF,PDIM,NPIXA1,DIM,ICURP,
     .                  N_CURR_ORD,VBUF,BKGVAL,BKGERR,MAX_DIM,PMSK,
     +                  PCOF1,PCOF2,POLORD,IDQC0)
   
      IMPLICIT NONE

      INTEGER NQC0
      PARAMETER(NQC0=12)
C     Interface variables            
            
     
      INTEGER I1
      REAL XSTP
      INTEGER IXMIN
      INTEGER NUM
      INTEGER PDIM                       !X dimention of mask
      INTEGER NPIXA1                     !Y dimention of mask
      INTEGER DIM                        !Y dimension of mask
      INTEGER ICURP                      !current raw position in table      
      INTEGER N_CURR_ORD                 !current order position
      INTEGER*2 PMSK(PDIM,NPIXA1)        !profile mask
      INTEGER POLORD                     !Order of polynomial
      INTEGER MAX_DIM                    !Expected max X ima size
                 
      REAL PBUF(PDIM,NPIXA1)             !Profile buffer      
      REAL VBUF(PDIM,NPIXA1)             !Variance buffer
      REAL BKGVAL(MAX_DIM)               !value of position
      REAL BKGERR(MAX_DIM)               !error on position
      REAL PCOF1(POLORD)                 !profile coefficients
      REAL PCOF2(POLORD)                 !profile coefficients
      REAL VQC0(NQC0)                    !aux variable for val col tab
C     Local variables
                        
      INTEGER kk
      INTEGER ISTAT
      INTEGER I
      INTEGER D1ROW                      !current raw
      INTEGER DTID1                      !Debug table Id.
      INTEGER DTID2                      !Id of debug table  (MIDAS env)
            
      INTEGER IDPCH                      !Id of table column (MIDAS env)
      INTEGER IDPF0                      !Id of table column (MIDAS env)
      INTEGER IDPER0                     !Id of table column (MIDAS env)
      INTEGER IDS0                       !Id of table column (MIDAS env)
      INTEGER IDICH                      !Id of table column (MIDAS env)
      INTEGER IDMSK0                     !Id of table column (MIDAS env)
      INTEGER IDXCH0                     !Id of table column (MIDAS env)
      INTEGER IDORD                      !Id of table column (MIDAS env)
      INTEGER IDFWHM                     !Id of table column (MIDAS env)
      INTEGER IDFWER                     !Id of table column (MIDAS env)
      INTEGER IDBKGE                     !Id of table column (MIDAS env)
      INTEGER IDBKGV                     !Id of table column (MIDAS env)
      INTEGER MADRID                     !(MIDAS env) memory address id
                  
      INTEGER IDQC0(NQC0)                  !aux variable for ID columns tab
      REAL X1                            !tmp holder for X position

      EXTERNAL POLYN3                    !Polynomial of degree 3
      
      COMMON /DBGORT/DTID1,DTID2         !to reduce par in subroutine call
      COMMON /QCF0/IDORD,IDPCH,IDICH,IDPER0,IDFWHM,IDFWER,IDBKGV,
     +               IDBKGE,IDMSK0,IDXCH0,IDPF0,IDS0
     
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'   !to get the definitions 
                                         !on the ST interfaces
      COMMON /VMR/MADRID(1)              !COMMON block for the 
                                         !pointer emulation in F77
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'   !to get data values for 
                                         !definitions above
   
      ISTAT=0 
      X1 = I1 - XSTP
     
      kk=1

      IF(ISTAT.LT.1) THEN
          DO I = IXMIN,IXMIN+NUM-1
             X1 = X1 + XSTP
             IF(PBUF(2,I).GT.0.AND.PBUF(2,I).LT.DIM) THEN       
c >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                D1ROW=kk+ICURP  

                VQC0(1)=   FLOAT(N_CURR_ORD)  !IDORD
                VQC0(2)=   PBUF(2,I)          !IDPCH
                VQC0(3)=   FLOAT(kk)          !IDICH
                VQC0(4)=   VBUF(2,I)          !IDPER0
                VQC0(5)=   PBUF(3,I)          !IDFWHM
                VQC0(6)=   VBUF(3,I)          !IFWER
                VQC0(7)=   BKGVAL(kk)         !IDBKGV
                VQC0(8)=   BKGERR(kk)         !IDBKGE
                VQC0(9)=   FLOAT(PMSK(2,I))   !IDMSK0
                VQC0(10)=  X1                 !IDXCH0
                VQC0(11)=  POLYN3(X1,PCOF1)   !IDPF0
                VQC0(12)=  POLYN3(X1,PCOF2)   !IDS0
          
               
                CALL TBRWRR(DTID1,D1ROW,11,IDQC0,VQC0,ISTAT)
c                CALL TBRWRR(DTID1,D1ROW,1,IDORD,
c     +                    FLOAT(N_CURR_ORD),ISTAT)
c                CALL TBRWRR(DTID1,D1ROW,1,IDPCH,
c     +                    PBUF(2,I),ISTAT)       !POSVAL(I-IXMIN+1) in fit
c                CALL TBRWRR(DTID1,D1ROW,1,IDICH,
c     +                    FLOAT(kk),ISTAT)
c                CALL TBRWRR(DTID1,D1ROW,1,IDPER0,
c     +                    VBUF(2,I),ISTAT)       !POSERR(I-IXMIN+1) in fit
c                CALL TBRWRR(DTID1,D1ROW,1,IDFWHM,
c     +                    PBUF(3,I),ISTAT)       !SIGVAL(I-IXMIN+1) in fit
c                CALL TBRWRR(DTID1,D1ROW,1,IDFWER,
c     +                    VBUF(3,I),ISTAT)       !SIGERR(I-IXMIN+1) in fit
c                CALL TBRWRR(DTID1,D1ROW,1,IDBKGV,
c     +                    BKGVAL(kk),ISTAT)      
                
c                CALL TBRWRR(DTID1,D1ROW,1,IDBKGE,
c     +                    BKGERR(kk),ISTAT)      
c                CALL TBRWRR(DTID1,D1ROW,1,IDMSK0,
c     +                    FLOAT(PMSK(2,I)),ISTAT)
c                CALL TBRWRR(DTID1,D1ROW,1,IDXCH0,
c     +                    X1,ISTAT)
c                CALL TBRWRR(DTID1,D1ROW,1,IDPF0,
c     +                    POLYN3(X1,PCOF1),ISTAT)
 
c                CALL TBRWRR(DTID1,D1ROW,1,IDS0,
c     +                    POLYN3(X1,PCOF2),ISTAT)      
             ENDIF
c >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>     
             kk=kk+1             
          ENDDO
          ISTAT=1
      ENDIF
            
      RETURN
      END
C==============================================================================      
      
 
 
 
 
