C $Id: qcotr1.for,v 1.2 2002/02/03 08:39:54 amodigli Exp $
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)echopt.for	2.4 (ESO-IPG) 12/6/91 12:26:19
C+
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  21:13 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR : A. Modigliani
C
C.IDENTIFICATION
C  subroutine qcotr1 derived from program  ECHOPT  version 1.0 011109 
C
C.KEYWORDS
C
C  ECHELLE, CASPEC, DATA EXTRACTION
C
C.PURPOSE
C Dump QC info on a table
C
C.SYNTAX
C
C.HISTORY:
C  2001.11.09-AM  Derived from necopt.for
C
C***************************************************************************
C------------------------------------------------------------------------------
C $Name:  $
C $Revision: 1.2 $
C $Log: qcotr1.for,v $
C Revision 1.2  2002/02/03 08:39:54  amodigli
C Eliminated unnecessary calls to error
C handling (mIDAS has its own staff)
C
C Revision 1.1  2001/11/09 18:01:42  amodigli
C Created extra modules as part of DFS
C code rev step 2
C
C
C------------------------------------------------------------------------------
C  who    when           why                               where
C  AM     09/11/01      Derived from necopt.for
C-----------------------------------------------------------------------

      SUBROUTINE QCOTR1(I1,XSTP,IXMIN,NUM,ICURP,X1,PCOF1,PMSK,PCOF2,
     +                  PDIM,NPIXA1,POLORD)

      IMPLICIT NONE
      
C     Inteface variables
      INTEGER I1
      INTEGER IXMIN
      INTEGER NUM
      INTEGER ICURP
      INTEGER PDIM                       !X dimention of mask
      INTEGER NPIXA1                     !Y dimention of mask
      INTEGER POLORD                     !Order of polynomial      
      INTEGER*2 PMSK(PDIM,NPIXA1)        !profile mask
      REAL PCOF1(POLORD)                 !profile coefficients
      REAL PCOF2(POLORD)                 !profile coefficients

C     Local variables

      REAL XSTP
      
      INTEGER ISTAT
      INTEGER kk
      INTEGER I
      INTEGER D1ROW                      !current raw
      
C     variables passed and set from common      
      INTEGER DTID1                      !Debug table Id.
      INTEGER DTID2                      !Id of debug table  (MIDAS env)
      INTEGER IDPF1                      !Id of table column (MIDAS env)
      INTEGER IDS1                       !Id of table column (MIDAS env)
      INTEGER IDMSK1                     !Id of table column (MIDAS env)
   
 
      
      REAL X1
      EXTERNAL POLYN3                    !Polynomial of degree 3      
      
C      COMMON /DBGORT/DTID1,DTID2         !to reduce par in subroutine call
      
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'   !to get the definitions 
                                         !on the ST interfaces
      INCLUDE '../incl/common_dbgort.inc'
      INCLUDE '../incl/common_qcf1.inc'
      INCLUDE '../incl/common_vmr.inc'
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'   !to get data values for 
                                         !definitions above      
               
      ISTAT=0
      X1 = I1 - XSTP
     
      kk=1
      IF(ISTAT.LT.1) THEN
          DO I = IXMIN,IXMIN+NUM-1
             X1 = X1 + XSTP

c >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> 
              D1ROW=kk+ICURP
             
              CALL TBRWRR(DTID1,D1ROW,1,IDPF1,
     +                    POLYN3(X1,PCOF1),ISTAT)  
              CALL TBRWRR(DTID1,D1ROW,1,IDMSK1,
     +                    FLOAT(PMSK(2,I)),ISTAT)              
              CALL TBRWRR(DTID1,D1ROW,1,IDS1,
     +                    POLYN3(X1,PCOF2),ISTAT) 
             
c >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>     
              kk=kk+1
          ENDDO
          ISTAT=1
      ENDIF      
      RETURN
      END
C==========================================================================      
      

