C $Id: qctsr.for,v 1.3 2002/08/16 15:21:23 amodigli Exp $
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
C MA 02139, USA.
C
C Corresponding concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
C @(#)echopt.for	2.4 (ESO-IPG) 12/6/91 12:26:19
C+
C.COPYRIGHT: Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C
C.VERSION: 1.0  ESO-FORTRAN Conversion, AA  21:13 - 3 DEC 1987
C
C.LANGUAGE: F77+ESOext
C
C.AUTHOR : M Peron, S. Wolf, A. Modigliani
C
C.IDENTIFICATION
C  subroutine qctsr derived from program  ECHOPT  version 1.0 011109 
C
C.KEYWORDS
C
C  ECHELLE, CASPEC, DATA EXTRACTION
C
C.PURPOSE
C Search column ID in table
C
C.SYNTAX
C
C.HISTORY:
C  2001.11.09-AM   Created from necopt.for  
C
C***************************************************************************
C------------------------------------------------------------------------------
C $Name:  $
C $Revision: 1.3 $
C $Log: qctsr.for,v $
C Revision 1.3  2002/08/16 15:21:23  amodigli
C speed-up
C
C Revision 1.2  2002/02/07 15:51:35  amodigli
C Added D1COL. Otherwise the program get
C screwed up. This was portability problem
C to Linux.
C
C Revision 1.1  2001/11/09 18:01:43  amodigli
C Created extra modules as part of DFS
C code rev step 2
C
C------------------------------------------------------------------------------
C  who    when           why                               where
C  AM     09/11/01   Created from necopt.for               all   
C  AM     16/08/02   Speed-up                              all  
C------------------------------------------------------------------------------
C  Role: Search column ID in table
C------------------------------------------------------------------------------

      SUBROUTINE QCTSR(D1NAME,ND1COL,D2NAME,ND2COL,D1COL,D2COL,IDQC0)
      
      IMPLICIT NONE
      INTEGER NQC0
      PARAMETER (NQC0=12)
C     Interface variables
      INTEGER ND1COL
      INTEGER ND2COL
      
      CHARACTER*64 D1NAME(ND1COL)        !Descriptor name
      CHARACTER*64 D2NAME(ND2COL)        !Descriptor name
            
C     Local variables
      INTEGER ILOOP      
      INTEGER D1COL(ND1COL)              !Descriptor id (MIDAS env)
      INTEGER D2COL(ND2COL)              !Descriptor id (MIDAS env)
      INTEGER ISTAT
     
      
C     variables passed and set from common      
      INTEGER DTID1                      !Debug table Id.
      INTEGER DTID2                      !Id of debug table  (MIDAS env)
            
      INTEGER IDPCH                      !Id of table column (MIDAS env)
      INTEGER IDPF0                      !Id of table column (MIDAS env)
      INTEGER IDPER0                     !Id of table column (MIDAS env)
      INTEGER IDS0                       !Id of table column (MIDAS env)
      INTEGER IDICH                      !Id of table column (MIDAS env)
      INTEGER IDMSK0                     !Id of table column (MIDAS env)
      INTEGER IDXCH0                     !Id of table column (MIDAS env)
      INTEGER IDORD                      !Id of table column (MIDAS env)
      INTEGER IDFWHM                     !Id of table column (MIDAS env)
      INTEGER IDFWER                     !Id of table column (MIDAS env)
      
      INTEGER IDPF1                      !Id of table column (MIDAS env)
      INTEGER IDS1                       !Id of table column (MIDAS env)
      INTEGER IDKS                       !Id of table column (MIDAS env)
      INTEGER IDDEG                      !Id of table column (MIDAS env) 
      INTEGER IDCHI0                     !Id of table column (MIDAS env) 
   
      INTEGER IDMSK1                     !Id of table column (MIDAS env)
 
      
      INTEGER IDBKGE                     !Id of table column (MIDAS env)
      INTEGER IDBKGV                     !Id of table column (MIDAS env)      
      INTEGER IDQC0(NQC0)                !aux variable to hold index col tab
    
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'   !to get the definitions 
                                         !on the ST interfaces
      INCLUDE '../incl/common_dbgort.inc'  
      INCLUDE '../incl/common_qc.inc'
      INCLUDE '../incl/common_qcf1.inc'  
      INCLUDE '../incl/common_vmr.inc'                                           

      INCLUDE 'MID_INCLUDE:ST_DAT.INC'   !to get data values for 
                                         !definitions above     
                                         
      
      D1NAME(1)=':ORDER'
      D1NAME(2)=':I_CH'
      D1NAME(3)=':X_CH_0'
      D1NAME(4)=':P_ERR0'
      D1NAME(5)=':S_CH_0'
      D1NAME(6)=':S_CH_1'
      D1NAME(7)=':P_FWHM'
      D1NAME(8)=':P_FWHM_ERR'
      D1NAME(9)=':P_CH'
      D1NAME(10)=':P_F0'
      D1NAME(11)=':P_F1'
      D1NAME(12)=':M0'
      D1NAME(13)=':M1'
      D1NAME(14)=':DEG'
      D1NAME(15)=':CHI0'
      D1NAME(16)=':KS'
      D1NAME(17)=':BKGVAL'
      D1NAME(18)=':BKGERR'
     
      DO ILOOP=1,ND1COL
         CALL TBCSER(DTID1,D1NAME(ILOOP),D1COL(ILOOP),ISTAT)
      ENDDO

      IDORD   = D1COL(1)
      IDICH  = D1COL(2)
      IDXCH0 = D1COL(3)
      IDPER0 = D1COL(4)
      IDS0   = D1COL(5)
      IDS1   = D1COL(6)
      IDFWHM = D1COL(7)
      IDFWER = D1COL(8)
      IDPCH  = D1COL(9)
      IDPF0  = D1COL(10)
      IDPF1  = D1COL(11)
      IDMSK0 = D1COL(12)
      IDMSK1 = D1COL(13)
      IDDEG  = D1COL(14)
      IDCHI0 = D1COL(15)
      IDKS   = D1COL(16)
      IDBKGV = D1COL(17)
      IDBKGE = D1COL(18)
 
c      CALL TBCSER(DTID1,':ORDER',IDORD,ISTAT)
c      CALL TBCSER(DTID1,':I_CH',IDICH,ISTAT)
c      CALL TBCSER(DTID1,':X_CH_0',IDXCH0,ISTAT)
c      CALL TBCSER(DTID1,':P_ERR0',IDPER0,ISTAT)
c      CALL TBCSER(DTID1,':S_CH_0',IDS0,ISTAT)
c      CALL TBCSER(DTID1,':S_CH_1',IDS1,ISTAT)
c      CALL TBCSER(DTID1,':P_FWHM',IDFWHM,ISTAT)
c      CALL TBCSER(DTID1,':P_FWHM_ERR',IDFWER,ISTAT)
c      CALL TBCSER(DTID1,':P_CH',IDPCH,ISTAT)
c      CALL TBCSER(DTID1,':P_F0',IDPF0,ISTAT)
c      CALL TBCSER(DTID1,':P_F1',IDPF1,ISTAT)
c      CALL TBCSER(DTID1,':M0',IDMSK0,ISTAT)
c      CALL TBCSER(DTID1,':M1',IDMSK1,ISTAT)
c      CALL TBCSER(DTID1,':DEG',IDDEG,ISTAT)
c      CALL TBCSER(DTID1,':CHI0',IDCHI0,ISTAT)
c      CALL TBCSER(DTID1,':KS',IDKS,ISTAT)
c      CALL TBCSER(DTID1,':BKGVAL',IDBKGV,ISTAT)
c      CALL TBCSER(DTID1,':BKGERR',IDBKGE,ISTAT)
 
      IDQC0(1)=   IDORD
      IDQC0(2)=   IDPCH
      IDQC0(3)=   IDICH
      IDQC0(4)=   IDPER0
      IDQC0(5)=   IDFWHM
      IDQC0(6)=   IDFWER
      IDQC0(7)=   IDBKGV
      IDQC0(8)=   IDBKGE
      IDQC0(9)=   IDMSK0
      IDQC0(10)=  IDXCH0
      IDQC0(11)=  IDPF0
      IDQC0(12)=  IDS0
         
      D2NAME(1)=':ORDER'
      D2NAME(2)=':I_CH'
      D2NAME(3)=':Y_CH'
      D2NAME(4)=':FLUX'
      DO ILOOP=1,4
         CALL TBCSER(DTID2,D2NAME(ILOOP),D2COL(ILOOP),ISTAT)
      ENDDO
          
      RETURN
      END
C==============================================================================
 
