/* ===========================================================================
 * $Id: physmod.h,v 1.3 2001/01/04 13:12:39 amodigli Exp $
 * $Name:  $
 * $Revision: 1.3 $
 * $Log: physmod.h,v $
 * Revision 1.3  2001/01/04 13:12:39  amodigli
 * Added Id, Name, Revision, Log conf. control info
 *
 * ===========================================================================
 */
/*+++ physmod.h ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 
 .COPYRIGHT	(C) 1998  European Southern Observatory
 
 .IDENT		
 
 .KEYWORDS	uves physical model, spectroscopy, echelle,
 
 .USAGE		.
 
 .INPUT		.
 		 
 .OUTPUT	.
 
 .RETURN	Q1:  0: successful return
 		    -1: a successful return failed
 
 .PURPOSE	Headers of UVES Physical Model Functions. 
 
 .ALGORITHM	UVES Physical Model.

 .ENVIRON	MIDAS, UVES context
    
 .LANGUAGE	C
 
 .AUTHOR	Pascal Ballester, Olivier BOITQUIN, ESO-DMD
 
 .VERSION	1.0 1999/07/01	Creation
                1.1 1999/10/06  ANSI part removed (see comment)!

 .COMMENT       No ANSI anymore due to problems on SUNS !!
----------------------------------------------------------------------------*/

  double lm, k, theta, *palpha, *pbeta;
  int m;
  char arm, CcdId;
  int disp;
  float binx, biny;
  double waveCent;
  double ccdrotred, ccdrotblue;
  double echred, echblue, xred, xblue;
  double xoff, yoff;
  double p, t, w;
  double lambda;
  /*double lm;*/
  /*double lm;*/
  /*double k;*/
  double alpha, beta;
  /*double k;*/
  /*double alpha, beta;*/
  /*int m;*/
  /*double k;*/
  /*double alpha;*/
  double l;
  /*int m;*/
  /*double lambda;*/
  double *pbetaech, *pbetacd, *pfc;
  double betacd, betaech;
  double *prech, *prcd, *pblz;
  double wave, order, rech, rcd, blz;
  double *pbinsize,*ppixscale,*ppixscalCD,*plinewidpx,*plinelenpx,*plinewidth,*presol;
  double *px, *py;
  double *plambda;
  double *pdm;
  double fc, x, y;
  /*int m;*/
  /*double *plambda;*/
  /*double fc, x, y;*/
  int *pm;
  /*double *plambda;*/
  /*double x, y;*/
  /*int m;*/
  double *lambdaC, *fsrStart, *fsrEnd;
  /*int m;*/
  /*double l;*/
  int *nx, *ny;

  extern void findAlphaBeta();
  extern int uvesConfig();
  extern void setIncidence();
  extern void setccdrot();
  extern void setOffset();
  extern double airIndex();
  extern void airConfig();
  extern double cameraFocal();
  extern int findM();
  extern double findML();
  extern double findL();
  extern double findBeta();
  extern void lm2beta();
  extern void beta2xy();
  extern void photobeta();
  extern void xyModel();
  extern void xy2beta();
  extern void pixscl();
  extern void beta2lamb();
  extern void lmfModel();
  extern void lModel();
  extern void lmBetaModel();
  extern void lmModel();
  extern void findFSR();
  extern double waveBin();
  extern void ccdSize();
  extern void xyRegres();

/*
  Global Variables and Constants
*/

extern double   cdgroov[4];
extern double   echgroov[2];
extern double   echblaz[2];
extern double   delta[2];
extern double   cdbeam[2];
extern float    bin[2];
extern double   pixsize[2];
extern double   ccdrot[2];
extern int      imsize[2];
extern int      rowsiz[2];
extern double   flipx;
extern double   flipy;

extern int      cfgindx;
extern int      XdispId;
extern int      echId;
extern double   alpha0cd, beta0cd;
extern char     armId;

extern double   DEG2RAD;
 
extern double   offsetx[6];
extern double   offsety[6];
/*extern double   pixscale[6];*/
/*extern double   rech, rcd, gam, blz;*/
