! $Id: uves_ccdtest.prg,v 1.16 2002/02/08 15:40:26 amodigli Exp $
!+++ UVES_CCDTEST +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT         uves_ccdtest.prg 
!
!.KEYWORDS      spectroscopy, echelle, CCD charcateristic
!
!.USAGE         @p (IDENT) incat
!
!.INPUT         incat   (P1): set of input frames (ascii list)
!				series of biases        [BIAS_x]
!				series of screen flats  [SCREEN_FLAT_x]
!
!.OUTPUT        
!
!.RETURN        Q1:  0: successful return
!                   -1: a successful return failed
!
!.DEFAULT       
!
!.PURPOSE       Perform CCD test to get CCD characteristics.
!
!.ALGORITHM     Makes use of procedures of MIDAS context CCDTEST
!
!.ENVIRON       UVES, ECHELLE and CCDTEST context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Andreas Kaufer, ESO
!
!.VERSION       1.0 1999/12/18  Created.
!
!.COMMENT       
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.16 $
! $Log: uves_ccdtest.prg,v $
! Revision 1.16  2002/02/08 15:40:26  amodigli
! Added P2 (name of output catalog) to fix
! an error using uves_ccdtest.sh
!
! Revision 1.15  2002/01/31 14:24:33  amodigli
! Version dumping one ARCFILE only in QC-LOG
!
! Revision 1.14  2001/09/17 10:05:07  amodigli
! Added UITi, TILT.POS key as requested from PSO
!
! Revision 1.13  2001/09/17 10:02:52  amodigli
! *** empty log message ***
!
! Revision 1.12  2001/09/10 15:22:24  amodigli
! Added some QC key as asked from PSO
!
! Revision 1.11  2001/07/15 14:18:58  amodigli
! Eliminated unnecessary call to uves_getpversion.prg
!
! Revision 1.10  2001/07/04 15:58:02  amodigli
! New QC1 naming conventions
!
! Revision 1.9  2001/06/20 14:21:15  amodigli
! Using QC1 LOG and PAF files
!
! Revision 1.8  2001/06/16 06:55:31  amodigli
! Changing QC-LOG naming conventions
!
! Revision 1.7  2001/01/04 10:39:40  amodigli
! Added Id, Name, Revision, Log conf. control info
!
!------------------------------------------------------------------------------
crossref incat

define/param p1 ? c "Enter name of input catalog (splitted):"
define/param p2 + c "Enter name of output catalog :"
define/local pid/c/1/15 "ccdtest"

define/local ccdbox/i/1/1 400


define/local in_cats/c*25/1/3 " " ALL +lower
define/local bs_cats/c*25/1/3 " " ALL +lower
define/local ff_cats/c*25/1/3 " " ALL +lower

define/local i1/i/1/1 0
define/local i2/i/1/1 0
define/local ccdidx/i/1/1 0
define/local catal/i/1/1 0

define/local ifrm/c/1/100 " " ALL
define/local prot/c/1/100 " " ALL
define/local modext/c/1/10 " " ALL
define/local do_class/c/1/25 " " ALL
define/local speed/c/1/25 " " ALL
define/local shutLOW/r/1/1  0
define/local shutHIGH/r/1/1 2
define/local minmax/r/1/2 0.0 0.0
define/local reffield/i/1/3 2,8,5
define/local date/c/1/30 " " all +lower

 
define/local dpr_type/c/1/80 " " all
define/local tpl_id/c/1/80 " " all
define/local arcfile/c/1/80 " " all
define/local pro_catg/c/1/80 " " all
define/local counter/i/1/1 0
 

if m$exist(p2) .eq. 0 .AND. p2(1:1) .ne. "+" -
  create/icat {p2} NULL {UVES_IDSTRNG} >Null

in_cats(1) = "sel{EXREDL}"				!into 3 catalogs:
in_cats(2) = "sel{EXREDU}"				!sel{EXREDL},
in_cats(3) = "sel{EXBLUE}"				!sel{EXREDU},
bs_cats(1) = "bs{EXREDL}"				!into 3 catalogs:
bs_cats(2) = "bs{EXREDU}"				!sel{EXREDL},
bs_cats(3) = "bs{EXBLUE}"				!sel{EXREDU},
ff_cats(1) = "ff{EXREDL}"				!into 3 catalogs:
ff_cats(2) = "ff{EXREDU}"				!sel{EXREDL},
ff_cats(3) = "ff{EXBLUE}"				!sel{EXREDU},

set/format

! Initializing CCD context
set/context ccdtest
!
if NICE_CREA .eq. "Y" then
  crea/disp 0
  crea/grap 0
endif

@p uves_ccdtest,SPLITCAT {p1}
define/local pn/i/1/1 0
define/local chip_id/i/1/1 0

do i1 = 1 3
  read/icat {bs_cats({i1})}
  read/icat {ff_cats({i1})}
  ! check if input catalog is empty
  catal = 0
  store/frame ifrm {bs_cats({i1})}.cat 1 break
  date   = "{{ifrm},ESO.TPL.START}"
  catal = 0
  store/frame ifrm {ff_cats({i1})}.cat 1 break
  config/instr {ifrm}
  modext = q2
  speed = "{{ifrm},{h_speed}}"			!get the readout characteristic
  @p uves_ccdtest,REPL_CH / {speed} _
  speed = outputc
  set/format I1 F1.0
  prot = "CCD{modext(1:2)}{CCD}_{speed}_{CCDBIN(1)}x{CCDBIN(2)}"
 
  mess/out 3 {pid} "STANDARD TEST REDUCTION PACKAGE"
  append/out "Doing a CCD test for:\n"
  append/out "  CCD:     {modext(2:2)}{CCD}\n"
  append/out "  MODE:    {speed}\n"
  append/out "  BINNING: {CCDBIN(1)}x{CCDBIN(2)}"
  mess/out 3 {pid}
 
!AKA  @p uves_ccdtestb ? {bs_cats({i1})}.cat {prot} median  {NICE_CREA} {SESSOUTV}
  @p uves_ccdtestb ? {bs_cats({i1})}.cat {prot} median {SESSOUTV}
 
  set/format i1 f6.2
  @p uves_ccdtestt ? {ff_cats({i1})}.cat {prot} ? {shutLOW},{shutHIGH} all {NICE_CREA} {SESSOUTV}
 
  if {CCDBIN(1)} .eq. 1 .AND. {CCDBIN(2)} .eq. 1 then
    @p uves_ccdtestc -
      {ff_cats({i1})}.cat {reffield({PATHID})} {ccdbox} Cont_{prot} {NICE_CREA} {SESSOUTV}
  endif
  
  set/midas output=no
  stat/tab {prot}.tbl #5
  minmax(1) = outputr(1)
  minmax(2) = outputr(2)
  stat/tab {prot}.tbl #6
  minmax(1) = minmax(1) + outputr(1)
  minmax(2) = minmax(2) + outputr(2)
  minmax(1) = minmax(1) * ADUCF / 2
  minmax(2) = minmax(2) * ADUCF / 2
  set/midas output=yes
  !
  ! Log data 
  !
  append/out  "SUMMARY STANDARD TEST CCD: {prot}\n"
  append/out  "BIASMEAN = {BIASMEAN} / mean bias level [ADU]\n"
  append/out  "BIASSIGM = {BIASSIGM} / sdev of mean bias [ADU]\n"
  append/out  "HOTPIX   = {HOT_PIX}  / no. of hot pix/cols\n"
  append/out  "DYNMIN   = {MINMAX(1)} / min. exp. level [e-]\n"
  append/out  "DYNMAX   = {MINMAX(2)} / max. exp. level [e-]\n"
  append/out  "COUNTS   = {COUNTS} / average countrate [ADU/sec]\n"
  append/out  "CONAD    = {ADUCF} / conversion factor [e-/ADU]\n"
  append/out  "ERRCONAD = {ERRCF} / error for conv. factor \n"
  append/out  "RON      = {ENOISE} / readout noise [e-] \n"
  append/out  "ERRRON   = {ERREN} / error for readout noise \n"
  append/out  "ESHUTTER = {ESHUTTER} / shutter error [sec]\n"
  append/out  "LINERRP  = {LINERR(6)} / linearity deviation [%]\n"
  append/out  "LINERRM  = {LINERR(5)} / linearity deviation [%]\n"
  mess/out 3 {pid}
  
  set/format i1       
  pn = {uves_portid({PATHID})}
  set/format 
  
 
  !
  ! output to descriptors of product table (SWO/AKA Dec 1999)
  !
  create/table test_{prot}.tbl 1 1 NULL
  set/format i1 f8.4,f8.4
  write/desc test_{prot}.tbl DATAMIN/r/1/1  {MINMAX(1)}
  write/dhelp test_{prot}.tbl DATAMIN "min. exp. level [e-]"
  write/desc test_{prot}.tbl DATAMAX/r/1/1  {MINMAX(2)}
  write/dhelp test_{prot}.tbl DATAMAX "max. exp. level [e-]"
  set/format
!
!the following to be commented out!
  if M$EXIST("Cont_{prot}.tbl") .EQ. 1 then
   copy/dk Cont_{prot}.tbl fields/r/1/9 res/r/1/9
   mess/out 3 {pid}  "REF F = {reffield({PATHID})} / reference field"
   set/format F4.2 I2
   mess/out 3 {pid}
  endif

  do_class = "CCD_TABLE{modext}"
  classify/product test_{prot}.tbl {do_class} {d_empty} {d_det} OK y n
  if p2(1:1) .ne. "+" add/icat {p2} test_{prot}.tbl >Null

  !
  ! output to the logging system (AKA 2000-03-18) 
  !
  
  ! To uniform ops-log filename  (AMO 2000-07-25)
 
 
  set/format F13.6 
  w/o {date}
 



qc1log/out 2 
set/format i1 f8.4,f8.4
qc1log/out 1 test_{prot}.tbl {h_qc_did}  {d_qc_did}  "Data Dictionary for QC"
qc1log/out 1 test_{prot}.tbl "PRO.REC1.PIPE.ID" "{p_version}" "Pipeline (unique) identifier" PRO
qc1log/out 1 test_{prot}.tbl "QC.TEST1.ID" "CCD-Test-Bias"  "Name of QC Test"

    chip_id = {{ifrm},ESO.DET.OUT{pn}.CHIP}
    store/frame ifrm {bs_cats({i1})}.cat 1 LAB1
    if m$existd(ifrm,h_dprtype) .eq. 1 then
      dpr_type = "{{ifrm},{h_dprtype}}"
      qc1log/out 1 test_{prot}.tbl {h_dprtype} "{dpr_type}" + DPR
    endif
    if m$existd(ifrm,h_tpid) .eq. 1 then
      tpl_id = "{{ifrm},{h_tpid}}"
      qc1log/out 1 test_{prot}.tbl {h_tpid} "{tpl_id}" + TPL
    endif
    catal = 0
LAB1:  
    !we store just the 1st frm to get the ARCFILE name (we rely that RB contains frms in increasing time order)
    store/frame ifrm {bs_cats({i1})}.cat 1 LAB2 
    if m$existd(ifrm,h_arcfile) .eq. 1 then
      counter = counter +1
      arcfile = "{{ifrm},{h_arcfile}}"
      qc1log/out 1 test_{prot}.tbl {h_arcfile} {arcfile} + PRIMARY-FITS
    endif
LAB2: 
   
   catal = 0  	
   store/frame ifrm {bs_cats({i1})}.cat 1 LAB3
    if m$existd(ifrm,h_procatg) .eq. 1 then
      pro_catg = "{{ifrm},{h_procatg}}"
      !NB to have the proper pro catg of the data product we use do_class:
      qc1log/out 1 test_{prot}.tbl {h_procatg} {do_class} + PRO
    endif
    qc1log/out 1 test_{prot}.tbl {h_pipefile} test_{prot}.tbl + PRO
    if m$existd(ifrm,"{h_inspath}") .eq. 1 then 
        qc1log/out 1 test_{prot}.tbl {h_inspath} {{ifrm},{h_inspath}}                 "Optical path used."         UVES_ICS
    else
       mess/out 2 {pid} "Missing descriptor {h_inspath}"
    endif
    if m$existd(ifrm,"{h_insmode}") .eq. 1 then 
       qc1log/out 1 test_{prot}.tbl {h_insmode} {{ifrm},{h_insmode}}                 "Instrument mode used."      UVES_ICS  
    else
       mess/out 2 {pid} "Missing descriptor {h_insmode}"
    endif
       qc1log/out 1 test_{prot}.tbl "DET.NAME" "{prot(5:8)}"          "Name of detector system"       CCDDCS
    if m$existd(ifrm,"{h_speed}") .eq. 1 then
       qc1log/out 1 test_{prot}.tbl {h_speed} {{ifrm},{h_speed}}             "Readout speed"              CCDDCS
    else
       mess/out 2 {pid} "Missing descriptor {h_speed}"
    endif
    if m$existd(ifrm,"{h_clock}") .eq. 1 then
       qc1log/out 1 test_{prot}.tbl {h_clock}  {{ifrm},{h_clock}}                    "Readout clock pattern used" CCDDCS
    else
       mess/out 2 {pid} "Missing descriptor {h_clock}"
    endif
    if m$existd(ifrm,"{h_nout}") .eq. 1 then
       qc1log/out 1 test_{prot}.tbl {h_nout}   {{ifrm},{h_nout}}                     "# of outputs"               CCDDCS
    else
       mess/out 2 {pid} "Missing descriptor {h_nout}"
    endif
    qc1log/out 1 test_{prot}.tbl {h_fits_nameccd({PATHID})} {h_nameccd({PATHID})} "Grating unique ID (hls)."   CCDDCS

    if m$existd(ifrm,"{h_xwinbin}") .eq. 1 then
       qc1log/out 1 test_{prot}.tbl {h_xwinbin} {{ifrm},{h_xwinbin}}        "Binning Factor along X"     CCDDCS
    else
       mess/out 2 {pid} "Missing descriptor {h_xwinbin}"
    endif
    if m$existd(ifrm,"{h_ywinbin}") .eq. 1 then
       qc1log/out 1 test_{prot}.tbl {h_ywinbin} {{ifrm},{h_ywinbin}}        "Binning Factor along Y"     CCDDCS
    else
       mess/out 2 {pid} "Missing descriptor {h_ywinbin}"
    endif
    if m$existd(ifrm,"{h_uit}") .eq. 1 then
       qc1log/out 1 test_{prot}.tbl {h_uit} {{ifrm},{h_uit}}        "User defined sub integration time"     CCDDCS
    else
       mess/out 2 {pid} "Missing descriptor {h_uit}"
    endif
    if m$existd(ifrm,"{h_tilt_pos({PATHID})}") .eq. 1 then
       qc1log/out 1 test_{prot}.tbl {h_tilt_pos({PATHID})} {{ifrm},{h_tilt_pos({PATHID})}}        "User defined sub integration time"     UVES_ICS
    else
       mess/out 2 {pid} "Missing descriptor {h_tilt_pos({PATHID})}"
    endif
    
    
    qc1log/out 1 test_{prot}.tbl "PRO.DATAAVG" {BIASMEAN}  "Mean of pixel values" PRO                       
    qc1log/out 1 test_{prot}.tbl "PRO.DATARMS" {BIASSIGM}  "Standard deviation of pixel values" PRO                         
    qc1log/out 1 test_{prot}.tbl "QC.OUT{pn}.RONAVG" {ENOISE}  "average readout noise"   
    qc1log/out 1 test_{prot}.tbl "QC.OUT{pn}.RONRMS" {ERREN}   "error for readout noise"   
    qc1log/out 1 test_{prot}.tbl "QC.NHOTPIX" {HOT_PIX}    "no. of hot pixels"                         
    qc1log/out 3
    write/descr test_{prot}.tbl PRO.DATAAVG/r/1/1 {BIASMEAN} 
    write/dhelp test_{prot}.tbl PRO.DATAAVG "Mean of pixel values"
    
    write/descr test_{prot}.tbl PRO.DATARMS/r/1/1 {BIASSIGM} 
    write/dhelp test_{prot}.tbl PRO.DATARMS "Standard deviation of pixel values"
    
qc1log/out 2 
set/format i1 f8.4,f8.4

qc1log/out 1 test_{prot}.tbl {h_qc_did}  {d_qc_did}  "Data Dictionary for QC"
qc1log/out 1 test_{prot}.tbl "PRO.REC1.PIPE.ID" "{p_version}" "Pipeline (unique) identifier" PRO
qc1log/out 1 test_{prot}.tbl "QC.TEST2.ID" "CCD-Test-Flatfield"  "Name of QC Test"




    store/frame ifrm {ff_cats({i1})}.cat 1 POS1
    if m$existd(ifrm,h_dprtype) .eq. 1 then
      dpr_type = "{{ifrm},{h_dprtype}}"
      qc1log/out 1 test_{prot}.tbl {h_dprtype} "{dpr_type}" + DPR
    endif
    if m$existd(ifrm,h_tpid) .eq. 1 then
      tpl_id = "{{ifrm},{h_tpid}}"
      qc1log/out 1 test_{prot}.tbl {h_tpid} "{tpl_id}" + TPL
    endif
    catal = 0
    counter = 0
POS1:  
    store/frame ifrm {ff_cats({i1})}.cat 1 POS2 
    if m$existd(ifrm,h_arcfile) .eq. 1 then
      arcfile = "{{ifrm},{h_arcfile}}"
      qc1log/out 1 test_{prot}.tbl {h_arcfile} {arcfile} + PRIMARY-FITS
    endif
    goto POS1
POS2:    
   catal = 0  	
   store/frame ifrm {ff_cats({i1})}.cat 1 LAB3
    if m$existd(ifrm,h_procatg) .eq. 1 then
      pro_catg = "{{ifrm},{h_procatg}}"
      qc1log/out 1 test_{prot}.tbl {h_procatg} {do_class} + PRO
    endif
    qc1log/out 1 test_{prot}.tbl {h_pipefile} test_{prot}.tbl + PRO
    if m$existd(ifrm,"{h_inspath}") .eq. 1 then 
        qc1log/out 1 test_{prot}.tbl {h_inspath} {{ifrm},{h_inspath}}                 "Optical path used."         UVES_ICS
    else
       mess/out 2 {pid} "Missing descriptor {h_inspath}"
    endif
    if m$existd(ifrm,"{h_insmode}") .eq. 1 then 
       qc1log/out 1 test_{prot}.tbl {h_insmode} {{ifrm},{h_insmode}}                  "Instrument mode used."      UVES_ICS  
    else
       mess/out 2 {pid} "Missing descriptor {h_insmode}"
    endif
         qc1log/out 1 test_{prot}.tbl "DET.NAME"        "{prot(5:8)}"          "Name of detector system"     CCDDCS
    if m$existd(ifrm,"{h_speed}") .eq. 1 then 
       qc1log/out 1 test_{prot}.tbl  {h_speed} {{ifrm},{h_speed}}              "Readout speed"              CCDDCS
    else
       mess/out 2 {pid} "Missing descriptor {h_speed}"
    endif
    if m$existd(ifrm,"{h_clock}") .eq. 1 then 
       qc1log/out 1 test_{prot}.tbl {h_clock}  {{ifrm},{h_clock}}                     "Readout clock pattern used" CCDDCS
    else
       mess/out 2 {pid} "Missing descriptor {h_clock}"
    endif
    if m$existd(ifrm,"{h_nout}") .eq. 1 then 
       qc1log/out 1 test_{prot}.tbl {h_nout}   {{ifrm},{h_nout}}                      "# of outputs"               CCDDCS
    else
       mess/out 2 {pid} "Missing descriptor {h_nout}"
    endif
    qc1log/out 1 test_{prot}.tbl {h_fits_nameccd({PATHID})} {h_nameccd({PATHID})}  "Grating unique ID (hls)."   CCDDCS
    if m$existd(ifrm,"{h_xwinbin}") .eq. 1 then 
       qc1log/out 1 test_{prot}.tbl {h_xwinbin} {{ifrm},{h_xwinbin}}         "Binning Factor along X"     CCDDCS
    else
       mess/out 2 {pid} "Missing descriptor {h_xwinbin}"
    endif
    if m$existd(ifrm,"{h_ywinbin}") .eq. 1 then 
    qc1log/out 1 test_{prot}.tbl {h_ywinbin} {{ifrm},{h_ywinbin}}         "Binning Factor along Y"     CCDDCS
    else
       mess/out 2 {pid} "Missing descriptor {h_ywinbin}"
    endif
    if m$existd(ifrm,"{h_uit}") .eq. 1 then
       qc1log/out 1 test_{prot}.tbl {h_uit} {{ifrm},{h_uit}}        "User defined sub integration time"     CCDDCS
    else
       mess/out 2 {pid} "Missing descriptor {h_uit}"
    endif
    if m$existd(ifrm,"{h_tilt_pos({PATHID})}") .eq. 1 then
       qc1log/out 1 test_{prot}.tbl {h_tilt_pos({PATHID})} {{ifrm},{h_tilt_pos({PATHID})}}        "User defined sub integration time"     UVES_ICS
    else
       mess/out 2 {pid} "Missing descriptor {h_tilt_pos({PATHID})}"
    endif 
  qc1log/out 1 test_{prot}.tbl "DATAMIN" {MINMAX(1)}   "Min Pixel Value" PRIMARY-FITS
  qc1log/out 1 test_{prot}.tbl "DATAMAX" {MINMAX(2)}   "Max Pixel Value" PRIMARY-FITS
  qc1log/out 1 test_{prot}.tbl "QC.CNTRATE" {COUNTS}  "Average countrate"
  qc1log/out 1 test_{prot}.tbl "QC.OUT{pn}.CONADAVG" {ADUCF} "average conversion factor" 
  qc1log/out 1 test_{prot}.tbl "QC.OUT{pn}.CONADRMS" {ERRCF} "error for conversion factor"  
  qc1log/out 1 test_{prot}.tbl "QC.SHUTERR" {ESHUTTER}       "shutter error"
  qc1log/out 1 test_{prot}.tbl "QC.LINERRP" {LINERR(6)}      "positive linearity deviation %"
  qc1log/out 1 test_{prot}.tbl "QC.LINERRM" {LINERR(5)}      "negative linearity deviation %"
 
 
  
 
  !
  if M$EXIST("Cont_{prot}.tbl") .EQ. 1 then
   copy/dk Cont_{prot}.tbl fields/r/1/9 res/r/1/9
   !am 15/06/01
   !set/format F4.2 I2
   qc1log/out 1 test_{prot}.tbl "QC.FIELDREF" {reffield({PATHID})} "reference field"
   do i2 = 1 9
       set/format i1 f8.4,f8.4
       qc1log/out 1 test_{prot}.tbl "QC.FRATIO{i2}" {res({i2})} "intensity ratio"
   enddo
  endif
   set/format
  qc1log/out 3
  !
  break:
  end:
enddo
!
set/format
!
if NICE_CREA .eq. "Y" then
  delete/disp 0
  delete/grap 0
endif
return 0 {do_class}


!=== SUBROUTINES ==============================================================

ENTRY SPLITCAT
define/param p1 ? c "Enter name of input image catalog:"

define/local ifrm/c/1/100 " " ALL
define/local modext/c/1/25 " " ALL
define/local frmtyp/c/1/25 " " ALL
define/local catal/i/1/1 0
define/local i1/i/1/1 0

creat/icat {in_cats(1)}.cat NULL {UVES_IDSTRNG} >Null
creat/icat {in_cats(2)}.cat NULL {UVES_IDSTRNG} >Null
creat/icat {in_cats(3)}.cat NULL {UVES_IDSTRNG} >Null
creat/icat {bs_cats(1)}.cat NULL {UVES_IDSTRNG} >Null
creat/icat {bs_cats(2)}.cat NULL {UVES_IDSTRNG} >Null
creat/icat {bs_cats(3)}.cat NULL {UVES_IDSTRNG} >Null
creat/icat {ff_cats(1)}.cat NULL {UVES_IDSTRNG} >Null
creat/icat {ff_cats(2)}.cat NULL {UVES_IDSTRNG} >Null
creat/icat {ff_cats(3)}.cat NULL {UVES_IDSTRNG} >Null

ILOOP:						!Loop through input image
  store/frame ifrm {p1} 1 ELOOP			!catalog in order to distribute
  						!input frames to separate
						!image catalogs being all of
  frmtyp = "{{ifrm},{UVES_IDSTRNG}}"		!the same data part.
  get/idex {frmtyp}				!Get identifier extension
  modext = q3
 
  branch modext(1:5) {EXREDL},{EXREDU},{EXBLUE} REDL,REDU,BLUE
  goto endbranch

REDL:	
  add/icat {in_cats(1)} {ifrm} >Null
  goto endbranch
REDU:
  add/icat {in_cats(2)} {ifrm} >Null
  goto endbranch
BLUE:
  add/icat {in_cats(3)} {ifrm} >Null
  goto endbranch

endbranch:
goto ILOOP
ELOOP:
						!Now the main catalog is
						!split into sub catalogs which
						!only contain data from ONE
catal = 0					!UVES arm.
do i1 = 1 3					!In the next step we have to
IDIST:						!extract the flats and the
  store/frame ifrm {in_cats({i1})}.cat 1 EDIST	!biases from the sub catalogs.
  frmtyp = "{{ifrm},{UVES_IDSTRNG}}"		!
  branch frmtyp(1:4) BIAS,SCRE BIAS,SCRE
    goto IDIST
BIAS:
    subtract/icat {in_cats({i1})} {ifrm} >Null
    add/icat {bs_cats({i1})} {ifrm} >Null
    goto IDIST
SCRE:
    subtract/icat {in_cats({i1})} {ifrm} >Null
    add/icat {ff_cats({i1})} {ifrm} >Null
    goto IDIST
EDIST:
  catal = 0					!reset for next scan
enddo

return 0



ENTRY REPL_CH

define/param P1 ? c "Enter character to replace: "
define/param P2 ? c "Enter string where character should be replaced: "
define/param P3 ? c "Enter new character: "


define/local i1/i/1/1 0
define/local len/i/1/1 0
define/local ch/c/1/4 " " ALL

len = m$strlen(P2)			!get length of string

i1 = m$index(P1,"blank")
if i1 .le. 0 ch = P1(1:1)		!if P1 not " " get replace character
					!from P1, ch is preset to blanks!

outputc = P2
do i1 = 1 len
  if outputc({i1}:{i1}) .eq. ch(1:1) outputc({i1}:{i1}) = P3(1:1)
enddo

return {len}
