! $Id: uves_getcfg.prg,v 1.2 2001/01/04 10:39:49 amodigli Exp $
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT   (C) 1998  European Southern Observatory (ESO)
!
!.IDENT       uves_getcfg.prg
!
!.KEYWORDS    Data reduction system configuration
!
!.USAGE       config/drs  cat_accept session
!
!.INPUT       cat_accept  (P1)   Name input frame catalog.
!
!.OUTPUT      OUPUTC is updated with the configuration file name.
!
!.RETURNS     The recipe returns 0 on success, otherwise 1. Keyword Q1 is
!             updated with the exit status. 
!
!.PURPOSE     The procedure detects a DRS configuration file in a list of
!             files and returns its name or "NONE" if no configuration file is
!             found.  
!   
!.ENVIRON     UVES context
!
!.LANGUAGE    MIDAS command language 98NOV.
!
!.AUTHOR      R. Palsa, ESO-DMO
!
!.VERSION     0.5  1998/04/01:  Creation
!	      1.0  1998/03/22:	Copy and adapted for UVES (SW)
!
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.2 $
! $Log: uves_getcfg.prg,v $
! Revision 1.2  2001/01/04 10:39:49  amodigli
! Added Id, Name, Revision, Log conf. control info
!
!------------------------------------------------------------------------------

define/param p1  ?      c    "Input frame catalog:"


! Procedure identification
define/local procID/c/1/80	"GetConfigFile"



! Local variables
define/local catal/i/1/1       0
define/local cat/c/1/20        {p1}
define/local cat_entry/c/1/80  " "   all



write/key outputc " " all

read_cat_entry:

store/frame cat_entry {cat} 1 exit_loop

inputc = "{{cat_entry},{UVES_IDSTRNG}}"
if m$index(inputc,ORDER_ID) .gt. 0 then
  outputc = cat_entry
else
  goto read_cat_entry
endif


exit_loop:

return 0
