! $Id: uves_nonlfit.prg,v 1.2 2001/01/04 10:39:40 amodigli Exp $
!+++ UVES_NONLFIT ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT	(C) 1998  European Southern Observatory
!
!.IDENT		uves_nonlfit.prg
!
!.KEYWORDS	Perform a non linear least squares fit
!
!.USAGE		@p (IDENT) dtbl ptbl acc
!
!.INPUT		dtbl	(P1): name of data table
!		ptbl	(P2): name of parameter table
!		accur   (P3): accuracy of fit
!		global keyword:
!		 INPUTI: column distribution of the tables (indices):
!                :X   :Y   :SIG   :FIT    :RESIDUAL:PARAM  :FIX    :RESULT
!                 1    2    3      4       5        1       2       3
!		is the expected distribution.
!		set correct column numbers if different, example:
!                 1    2    4      3       5        1       3       2
!
!
!.OUTPUT	updated data and parameter table
!
!.RETURN	Q1:  0: successful return
!		     otherwise: a successful return failed
!		OUTPUTR: CHI^2 of fit
!
!.DEFAULT
!
!.PURPOSE	Perform a non linear least squares fit
!
!.ALGORITHM	Calls uves_nonlfit.exe
!
!.ENVIRON	UVES, CCDRED context
!   
!.LANGUAGE	MIDAS 98NOV
!
!.AUTHOR	Sebastian Wolf, ESO-DMO
!
!.VERSION	0.9 1998/02/04	Creation
!
!.COMMENT
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.2 $
! $Log: uves_nonlfit.prg,v $
! Revision 1.2  2001/01/04 10:39:40  amodigli
! Added Id, Name, Revision, Log conf. control info
!
!------------------------------------------------------------------------------
!
! Check parameters
!
define/param p1 ? c "Enter name of data table: "
define/param p2 ? c "Enter name of parameter table: "
define/param p3 ? n "Enter accuracy of fit (chi^2 difference):"
define/param p4 ? n "Enter fit function to be used (1,2..):"
!
! local variable declaration
!

IN_A = P1
IN_B = P2
INPUTR(1) = {P3}
INPUTI(9) = {P4}

run PIPE_EXE:uves_nonlfit.exe

return {Q1}
