! $Id: uves_savcal.prg,v 1.2 2001/01/04 10:39:32 amodigli Exp $
!+++ UVES_SAVECAL +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT         uves_savecal.prg
!
!.KEYWORDS      spectroscopy, echelle, calibrations
!
!.USAGE         @p (IDENT) catalog path [cattyp]
!
!.INPUT         catalog (P1): catalog with reference frames or POSTSCRIPT files
!               path    (P2): path to your calibration database
!               cattyp  (P3): type of catalog. If the catalog is not a IMAGE
!				catalog you have to specify the type!
!
!.OUTPUT        
!
!.RETURN        Q1:  0: successful return
!                   -1: a successful return failed
!
!.DEFAULT	P2	
!
!.PURPOSE       Save all files of the catalog in the calibration database.
!
!.ALGORITHM     Loops through the catalog and does a -copy.
!
!.ENVIRON       
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       1.0 1999/10/15  Created.
!
!.COMMENT	The input catalog is usually the result catalog of PREP/CALDB.
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.2 $
! $Log: uves_savcal.prg,v $
! Revision 1.2  2001/01/04 10:39:32  amodigli
! Added Id, Name, Revision, Log conf. control info
!
!------------------------------------------------------------------------------
!
define/param p1 ? c "Enter INPUT catalog:"
define/param p2 HOME:CALDB c "Enter path to CALIB. DATABASE (e.g. HOME:CALDB):"
define/param p3 I c "Enter catalog type (A: ascii, I: image, T: table):"

define/local pid/c/1/15 "savcal" 

define/local catal/i/1/1 0
define/local num/i/1/1 0


show/{p3}cat {p1} >Null			!check if INPUT catalog is empty
if outputi(1) .eq. 0 goto ERR1
num = outputi(1)

LOOP:
store/frame in_a {p1} 1 FINI
  mess/out 3 {pid} "copy {in_a} -> {p2}"
  -copy {in_a} {p2}
  goto LOOP
FINI:
-copy {p1} {p2}
return {num}


ERR1:
  mess/out 1 {pid} "INPUT catalog `{p1}` is empty !"
  return -1
