! $Id: uves_selgraph.prg,v 1.2 2001/01/04 10:39:31 amodigli Exp $
!+++ UVES_SELGRAPH ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT         uves_selgraph.prg
!
!.KEYWORDS      graphics window
!
!.USAGE         @p (IDENT) pathid
!
!.INPUT         pathid	(P1): pathid of actual optical path (BLUE, REDL, REDU)
!
!.OUTPUT        
!
!.RETURN        Q1: >0: successful return = selected graphics window
!                   -1: a successful return failed
!
!.DEFAULT	{PATHID}
!
!.PURPOSE       Select the 'correct' graphics window.
!
!.ALGORITHM     The two first graphics windows in the UVES environment are
!		dedicated to certain optical paths:
!		1: BLUE or REDL, 2: REDU
!
!		Each optical path has its own id -- pathid:
!		REDL=1, REDU=2, BLUE=3.
!		A simple arithmetic determines the 'correct' graphics window.
!
!.ENVIRON       UVES context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       1.0 1999/07/14  Created.
!
!.COMMENT
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.2 $
! $Log: uves_selgraph.prg,v $
! Revision 1.2  2001/01/04 10:39:31  amodigli
! Added Id, Name, Revision, Log conf. control info
!
!------------------------------------------------------------------------------

define/param p1 {PATHID} n "Enter pathid of optical path (1..3):"

define/local i1/i/1/1 0

set/format I1
i1 = {p1} - 1
@p uves_mod {i1} 2 >Null
i1 = {q1} + 1
assign/grap g,{i1}

return {i1}
