! $Id: uves_stability.prg,v 1.2 2001/01/04 10:39:29 amodigli Exp $
!+++ UVES_SATBILITY ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT         uves_stability.prg 
!
!.KEYWORDS      spectroscopy, echelle, CCD charcateristic
!
!.USAGE         @p (IDENT) incat
!
!.INPUT         incat   (P1): set of input frames (ascii list)
!				series of formatchecks  [ ]
!				line reference table [LINE_REFER_TABLE]
!
!.OUTPUT        
!
!.RETURN        Q1:  0: successful return
!                   -1: a successful return failed
!
!.DEFAULT       
!
!.PURPOSE       Perform stability test
!
!.ALGORITHM     Makes use of procedures of MIDAS context CCDTEST
!
!.ENVIRON       UVES, ECHELLE and CCDTEST context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Andreas Kaufer, ESO
!
!.VERSION       1.0 2000/01/12  Created.
!
!.COMMENT       
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.2 $
! $Log: uves_stability.prg,v $
! Revision 1.2  2001/01/04 10:39:29  amodigli
! Added Id, Name, Revision, Log conf. control info
!
!------------------------------------------------------------------------------

crossref incat

define/param p1 ? c "Enter name of input catalog (splitted):"

define/local pid/c/1/15 "uves_stability"

define/local in_cats/c*25/1/3 " " ALL +lower
define/local out_tab/c*25/1/3 " " ALL +lower
define/local modtab/C/1/25 "mline"

define/local i1/i/1/1 0
define/local i2/i/1/1 0
define/local med/i/1/1 0
define/local catal/i/1/1 0


define/local ifrm/c/1/100 " " ALL
define/local out/c/1/100 " " ALL
define/local prot/c/1/100 " " ALL
define/local modext/c/1/10 " " ALL
define/local do_class/c/1/25 " " ALL
define/local speed/c/1/25 " " ALL
define/local shutLOW/r/1/1  0
define/local shutHIGH/r/1/1 2
define/local minmax/r/1/2 0.0 0.0
define/local reffield/i/1/3 2,8,5

in_cats(1) = "sel{EXREDL}"				!into 3 catalogs:
in_cats(2) = "sel{EXREDU}"				!sel{EXREDL},
in_cats(3) = "sel{EXBLUE}"				!sel{EXREDU},
							!sel{EXBLUE}
out_tab(1) = "stab{EXREDL}"
out_tab(2) = "stab{EXREDU}"
out_tab(3) = "stab{EXBLUE}"

set/format
!
!if NICE_CREA .eq. "Y" then
!  crea/disp 0
!  crea/grap 0
!endif

search/icat prod{p1} {LINCAT_ID} NB                 !get reference line catalog
if m$strlen(out_a) .eq. 0 then
  mess/out 1 {pid} "No line reference table found!\n"
  return -1
else
  set/echelle LINCAT={out_a}
endif

@p uves_stability,SPLITCAT {p1}

do i1 = 1 3
  read/icat {in_cats({i1})}
  ! check if input catalog is empty
  catal = 0
  store/frame ifrm {in_cats({i1})}.cat 1 break

  catal = 0
  store/frame ifrm {in_cats({i1})}.cat 1 break
  config/instr {ifrm}
  modext = q2

  out = "{out_tab({i1})}"
!
  crea/tab {out} 4 1000
  crea/col {out} :filename    C*35 
  crea/col {out} :JD24        R*8   F13.4
  crea/col {out} :P   "mbar"  R*4   F7.2
  if i1 .eq. 3 then 
   crea/col {out} :Tblue      R*4   F7.2
  else
   crea/col {out} :Tred "C"   R*4   F7.2
  endif
  crea/col {out} :dX  "pixel" R*4   F7.4
  crea/col {out} :dXm "pixel" R*4   F7.4
  crea/col {out} :dY  "pixel" R*4   F7.4
  crea/col {out} :dYm "pixel" R*4   F7.4
!

  catal = 0
  i2 = 0
  loop:
    store/frame ifrm {in_cats({i1})}.cat 1 continue
    @p uves_predict {ifrm} {LINCAT}
!
    i2 = i2 + 1
    {out},:filename,@{i2} = "{{ifrm},ARCFILE}"
    copy/dk {ifrm} O_TIME/D/4/1 jd24/d/1/1
    {out},:jd24,@{i2}     = jd24
    {out},:P,@{i2}        = {{ifrm},ESO.INS.SENS26.MEAN}
    if i1 .eq. 3 then
     {out},:Tblue,@{i2}    = {{ifrm},ESO.INS.TEMP1.MEAN}
    else 
     {out},:Tred,@{i2}     = {{ifrm},ESO.INS.TEMP2.MEAN}
    endif
!
    if i2 .eq. 1 then
     copy/tab {modtab} {modtab}REF	        
     comp/tab {modtab}REF :X = :XMES
     comp/tab {modtab}REF :Y = :YMES
     comp/tab {modtab}REF :S = :STATUS
    endif
!
    copy/tab {modtab} {modtab}{i2}	        
    comp/tab {modtab}{i2} :X{i2} = :XMES
    comp/tab {modtab}{i2} :Y{i2} = :YMES
    comp/tab {modtab}{i2} :WAVE{i2} = :WAVE
!
    copy/tt  {modtab}{i2} :X{i2}    {modtab}REF  	
    copy/tt  {modtab}{i2} :Y{i2}    {modtab}REF  	
    copy/tt  {modtab}{i2} :WAVE{i2} {modtab}REF  	
    copy/tt  {modtab}{i2} :S{i2}   {modtab}REF  	
!
    comp/tab {modtab}REF :DX = :X{i2}-:X
    comp/tab {modtab}REF :DY = :Y{i2}-:Y
    comp/tab {modtab}REF :DW = ABS(:WAVE{i2}-:WAVE)  
    sele/tab {modtab}REF :DW.lt.0.001.AND.S{i2}.EQ.0.AND.S.EQ.0  {SESSOUTV}
    copy/tab {modtab}REF &REF
!    assign/gra G,0
!    set/gra 
!    plot/tab &REF :Y :DX
!    wait 1	
!    plot/tab &REF :X :DY
!      
    stat/tab &REF :DX	{SESSOUTV}
    med = outputi(2)/2
    {out},:dX,@{i2} = outputr(3)    
    sort/tab &REF :DX     
    {out},:dXm,@{i2} = {&REF,:DX,@{med}}   
!
    stat/tab &REF :DY   {SESSOUTV}
    {out},:dY,@{i2} = outputr(3)    
    sort/tab &REF :DY     
    {out},:dYm,@{i2} = {&REF,:DY,@{med}}   
 !   	
    sele/tab {modtab}REF all
!
  goto loop
  continue:
!
! Log data 
!
  append/out  "SUMMARY STABILTY TEST: {prot}\n"
  mess/out 3 {pid}
  read/tab {out}
!
  break:
enddo
!
set/format
!
!if NICE_CREA .eq. "Y" then
!  delete/disp 0
!  delete/grap 0
!endif
return 0 {do_class}


!=== SUBROUTINES ==============================================================

ENTRY SPLITCAT
define/param p1 ? c "Enter name of input image catalog:"

define/local ifrm/c/1/100 " " ALL
define/local modext/c/1/25 " " ALL
define/local frmtyp/c/1/25 " " ALL
define/local catal/i/1/1 0
define/local i1/i/1/1 0

creat/icat {in_cats(1)}.cat NULL {UVES_IDSTRNG} >Null
creat/icat {in_cats(2)}.cat NULL {UVES_IDSTRNG} >Null
creat/icat {in_cats(3)}.cat NULL {UVES_IDSTRNG} >Null

ILOOP:                                          !Loop through input image
  store/frame ifrm {p1} 1 ELOOP                 !catalog in order to distribute
                                                !input frames to separate
                                                !image catalogs being all of
  frmtyp = "{{ifrm},{UVES_IDSTRNG}}"            !the same data part.
  get/idex {frmtyp}                             !Get identifier extension
  modext = q3

  branch modext(1:5) {EXREDL},{EXREDU},{EXBLUE} REDL,REDU,BLUE
  goto endbranch

REDL:   
  add/icat {in_cats(1)} {ifrm} >Null
  goto endbranch
REDU:
  add/icat {in_cats(2)} {ifrm} >Null
  goto endbranch
BLUE:
  add/icat {in_cats(3)} {ifrm} >Null
  goto endbranch

endbranch:
goto ILOOP
ELOOP:


ENTRY REPL_CH

define/param P1 ? c "Enter character to replace: "
define/param P2 ? c "Enter string where character should be replaced: "
define/param P3 ? c "Enter new character: "


define/local i1/i/1/1 0
define/local len/i/1/1 0
define/local ch/c/1/4 " " ALL

len = m$strlen(P2)			!get length of string

i1 = m$index(P1,"blank")
if i1 .le. 0 ch = P1(1:1)		!if P1 not " " get replace character
					!from P1, ch is preset to blanks!

outputc = P2
do i1 = 1 len
  if outputc({i1}:{i1}) .eq. ch(1:1) outputc({i1}:{i1}) = P3(1:1)
enddo

return {len}
