! $Id: uves_tutorial.prg,v 1.8 2002/10/25 09:59:05 amodigli Exp $
!+++ UVES_TUTORIAL +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT         uves_tutorial.prg
!
!.KEYWORDS      uves, spectroscopy, echelle
!
!.USAGE         @p (IDENT) 
!
!.INPUT         
!				
!
!.OUTPUT        
!
!.RETURN        Q1:  0: successful return
!                   -1: a successful return failed
!
!.DEFAULT	    P1
!
!		
!
!.PURPOSE       Demonstration procedure of new uves package
!
!.SYNTAX	   tutorial/uves
!
!.ALGORITHM     
!
!.ENVIRON       UVES, ECHELLE context
!   
!.LANGUAGE      MIDAS 99NOV
!
!.AUTHOR        Olivier BOITQUIN, ESO-DMO
!
!.VERSION       2000/05/08 Created
!
!.COMMENT	   
!
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.8 $
! $Log: uves_tutorial.prg,v $
! Revision 1.8  2002/10/25 09:59:05  amodigli
! Faster version of tutorial
!
! Revision 1.7  2001/01/04 10:39:55  amodigli
! Added Id, Name, Revision, Log conf. control info
!
!------------------------------------------------------------------------------
!
! 
!
DEFINE/LOCAL LOOP/I/1/1    0
!
define/local ifrm/c/1/100 " " ALL
define/local main_prod/c/1/25 " " all
define/local MID_TEST/c/1/100 " " ALL
define/local catal/i/1/1 0 
!
config/disp
! 
!  get the necessary data files from $MID_HOME/demo/raw
! 
WRITE/OUT "Transfering demo images from MID_TEST..."
!
! Temporaly:  MID_TEST = oboitqui/midas/tuto/demo
write/key uves_home/c/1/100 " " ALL
uves_home = m$symbol("UVES_HOME")
MID_TEST = "{UVES_HOME}/tutorial/demo/"
write/out  "loading data from {MID_TEST}....."
!
!set/midas dpath={MID_TEST}
$ln -s {MID_TEST}uves_arc_lamp_form_blue.fits arc_lamp_form_blue.fits
$ln -s {MID_TEST}uves_arc_lamp_blue.fits arc_lamp_blue.fits
$ln -s {MID_TEST}uves_order_flat_blue.fits order_flat_blue.fits
$ln -s {MID_TEST}uves_flat_blue1.fits flat_blue1.fits
$ln -s {MID_TEST}uves_flat_blue2.fits flat_blue2.fits
$ln -s {MID_TEST}uves_flat_blue3.fits flat_blue3.fits

$ln -s {MID_TEST}uves_bias_blue1.fits bias_blue1.fits
$ln -s {MID_TEST}uves_bias_blue2.fits bias_blue2.fits
$ln -s {MID_TEST}uves_bias_blue3.fits bias_blue3.fits
$ln -s {MID_TEST}uves_bias_blue4.fits bias_blue4.fits
$ln -s {MID_TEST}uves_bias_blue5.fits bias_blue5.fits
$ln -s {MID_TEST}uves_science_blue.fits science_blue.fits
$ln -s {MID_TEST}uves_standard_blue.fits standard_blue.fits

$ln -s {MID_TEST}uves_thargood_2.tfits thargood_2.tfits
$ln -s {MID_TEST}uves_flxstd.tfits flxstd.tfits
$ln -s {MID_TEST}uves_atmoexan.tfits atmoexan.tfits

!@p uves_tutorial,cpy {MID_TEST}uves_thargood_2.tfits thargood_2.tbl
!@p uves_tutorial,cpy {MID_TEST}uves_flxstd.tfits flxstd.tbl
!@p uves_tutorial,cpy {MID_TEST}uves_atmoexan.tfits atmoexan.tbl

indisk/fits thargood_2.tfits thargood_2.tbl
indisk/fits flxstd.tfits flxstd.tbl
indisk/fits atmoexan.tfits atmoexan.tbl

write/out
write/out "Create input fits frame calalogue
creat/icat iframes.cat null DO_CLASSIFICATION
add/icat iframes.cat *.fits >Null
!add/icat iframes.cat uves_arc_lamp_form_blue.fits
!add/icat iframes.cat uves_arc_lamp_blue.fits
!add/icat iframes.cat uves_order_flat_blue.fits
!add/icat iframes.cat uves_flat_blue1.fits
!add/icat iframes.cat uves_flat_blue2.fits
!add/icat iframes.cat uves_flat_blue3.fits

!add/icat iframes.cat uves_bias_blue1.fits
!add/icat iframes.cat uves_bias_blue2.fits
!add/icat iframes.cat uves_bias_blue3.fits
!add/icat iframes.cat uves_bias_blue4.fits
!add/icat iframes.cat uves_bias_blue5.fits
!add/icat iframes.cat uves_science_blue.fits
!add/icat iframes.cat uves_standard_blue.fits

write/out
write/out "Transpose and flip all the frames"
split/uves iframes.cat


write/out
read/icat split.cat


write/out
write/out "Create format check frame catalogue"
write/out
creat/icat fmtframes.cat null DO_CLASSIFICATION
add/icat fmtframes.cat arc_lamp_form*.bdf >Null
read/icat fmtframes.cat

write/out
write/out "Predict Order positions and line positions"
write/out
SET/ECHE LINCAT=thargood_2.tbl

LOOP:
  store/frame ifrm fmtframes.cat 1 ENDLOOP
  PREDIC/UVES {ifrm} {LINCAT} predicO.cat
  if {q1} .ne. 0 goto ABORT			!An error had occured.
  main_prod = q2
  psf/uves {ifrm}
  goto LOOP
ENDLOOP:
write/out
read/icat predicO.cat
write/out
write/out "Order positions and line positions are predicted."


write/out
write/out "Create order flat field frame catalogue"
write/out
creat/icat ordFF.cat null DO_CLASSIFICATION
add/icat ordFF.cat order_flat_*.bdf >Null
write/out
read/icat ordFF.cat
write/out
write/out "Define Order Positions"
write/out
ORDERP/UVES ordFF.cat drs.cat predicO.cat
write/out
read/icat drs.cat


write/out
write/out "Create arc lamp frame catalogue"
write/out
creat/icat ref.cat null DO_CLASSIFICATION
add/icat ref.cat thargood_2.tbl >Null
add/icat ref.cat predicO.cat >Null
add/icat ref.cat drs.cat >Null
write/out
read/icat ref.cat
write/out
creat/icat arc_lamp.cat null DO_CLASSIFICATION
add/icat arc_lamp.cat arc_lamp_*.bdf >Null
subtract/icat arc_lamp.cat arc_lamp_form*.bdf
write/out
read/icat arc_lamp.cat
write/out
write/out "Wavelength Calibration"
write/out
WAVECA/UVES arc_lamp.cat prod.cat ref.cat
write/out
read/icat prod.cat
add/icat ref.cat prod.cat >Null
write/out
read/icat ref.cat


write/out
write/out "Create bias frame catalogue"
write/out
creat/icat bias.cat null DO_CLASSIFICATION
add/icat bias.cat bias_*.bdf >Null
write/out
read/icat bias.cat
write/out
write/out "Make master bias frame"
write/out
MASTER/UVES bias.cat master_bias.cat ref.cat
write/out
read/icat master_bias.cat
add/icat ref.cat master_bias.cat >Null


write/out
write/out "Create flat frame catalogue"
write/out
creat/icat flat.cat null DO_CLASSIFICATION
add/icat flat.cat flat_*.bdf >Null
write/out
read/icat flat.cat
write/out
write/out "Make master flat field frame"
write/out
MASTER/UVES flat.cat master_flat.cat ref.cat
write/out
read/icat master_flat.cat
add/icat ref.cat master_flat.cat >Null



write/out
write/out "Create standard star frame catalogue"
write/out
creat/icat standard.cat null DO_CLASSIFICATION
add/icat standard.cat standard_*.bdf >Null
write/out
read/icat  standard.cat
write/out
write/out "Science Reduction of the standard star"
write/out
REDUCE/UVES standard.cat redu_resp.cat ref.cat EXTRACT OPTIMAL MEDIAN
write/out
read/icat redu_resp.cat
copy/dd flxstd.tbl eso.pro.catg flxstd.tbl DO_CLASSIFICATION
add/icat ref.cat flxstd.tbl >Null
write/out
write/out "Compute the instrumental Response"
write/out
RESPON/UVES redu_resp.cat resp.cat ref.cat
add/icat ref.cat resp.cat >Null
write/out
read/icat resp.cat
write/out
copy/dd atmoexan.tbl eso.pro.catg atmoexan.tbl DO_CLASSIFICATION 
add/icat ref.cat atmoexan.tbl >Null
EFFICI/UVES standard.cat resp.cat ref.cat



write/out
write/out "Create science object frame catalogue"
write/out
creat/icat science.cat null DO_CLASSIFICATION
add/icat science.cat science_*.bdf >Null
write/out
read/icat  science.cat 
write/out
write/out "Science Reduction of the science object"
write/out
REDUCE/UVES science.cat redu_sci.cat ref.cat EXTRACT OPTIMAL MEDIAN
write/out
read/icat redu_sci.cat
write/out
write/out "  Termination"

!set/midas dpath=


!*********************************************************

ENTRY CPY

DEFINE/PARAM   P1   ?   C  "Source:"
DEFINE/PARAM   P2   ?   C  "Object:"


IF M$EXIST(P2) .EQ. 0  THEN
        indisk/fits {p1} {p2} >Null
        WRITE/OUT "Copied/converted {P1} to {P2}"
ENDIF

RETURN
