! $Id: uves_updcat.prg,v 1.2 2001/01/04 10:39:57 amodigli Exp $
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT   (C) 1998  European Southern Observatory (ESO)
!
!.IDENT       uves_updcat.prg
!
!.KEYWORDS    Update super recipe catalog.
!
!.USAGE       update/catalog  cat_in cat_out
!
!.INPUT       cat_in      (P1)    Source catalog
!
!.OUTPUT      cat_out     (P2)    Destination catalog
!
!.RETURNS     The procedure returns 0 on success, otherwise 1. Keyword Q1 is
!             updated with the exit status. 
!
!.PURPOSE     The procedure appends all catalog entries found in cat_in to
!             cat_out. 
!
!.ENVIRON     UVES context
!
!.LANGUAGE    MIDAS command language 98NOV.
!
!.AUTHOR      R. Palsa, ESO-DMO
!
!.VERSION     0.5  1998/04/27:  Creation
!
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.2 $
! $Log: uves_updcat.prg,v $
! Revision 1.2  2001/01/04 10:39:57  amodigli
! Added Id, Name, Revision, Log conf. control info
!
!------------------------------------------------------------------------------


crossref input output

define/param p1  ?      c    "Input catalog:"
define/param p2  ?      c    "Output catalog:"

define/maxpar 2


! Procedure identification
define/local procID/c/1/80	"UpdateCatalog"



! Local variables
define/local catal/i/1/1       0
define/local n_frames/i/1/1    0
define/local cat_entry/c/1/80  " "  all



cat_loop:

store/frame cat_entry {p1} 1 finish
add/icat {p2} {cat_entry} >Null
n_frames = n_frames + 1
goto cat_loop

finish:
set/format i1
mess/out 3 {procID} "Catalog {p2} updated with {n_frames} frames."
set/format

return 0
