#!/bin/sh
# $Id: uves_stability.sh,v 1.8 2002/06/04 14:49:55 amodigli Exp $
#+++ UVES_CCDTEST +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#
#.COPYRIGHT     (C) 1998  European Southern Observatory
#
#.IDENT         stability.sh
#
#.KEYWORDS      spectroscopy, echelle, calibrations
#
#.USAGE         call from GASGANO or from UNIX prompt
#
#                       Reference Formatcheck frame [MASTER_FORM_x]
#                       (must be the first one)
#                       Set of Formatcheck frames [ARC_LAMP_FORM_x]
#                       ThAr line table   [LINE_REFER_TABLE]
#
#.OUTPUT        
#
#.RETURN        
#
#.DEFAULT	no
#
#.PURPOSE       
#
#.ALGORITHM     
#
#.ENVIRON       UVES context
#   
#.LANGUAGE      shell script and MIDAS 99NOV
#
#.AUTHOR        Andreas Kaufer, ESO-PSO
#
#.VERSION       1.0 2000/01/12  Created.
#
#.COMMENT
#------------------------------------------------------------------------------
# $Name:  $
# $Revision: 1.8 $
# $Log: uves_stability.sh,v $
# Revision 1.8  2002/06/04 14:49:55  amodigli
# Simplified (compacted) using common scripts.
# Now each main script need to be in the
# PIPE_HOME/uves/uves/scripts directory with the
# common other ones.
#
# Revision 1.7  2002/02/08 08:52:39  amodigli
# Made it portable to HP-UX,SunOS,Linux
#
# Revision 1.6  2001/02/12 14:53:09  amodigli
# Made changes to pass to new
# pipeline structure for 01FEB
#
# Revision 1.5  2001/01/04 14:16:36  amodigli
# Added Id, Name, Revision, Log conf. control info
#
#------------------------------------------------------------------------------
# Note:
#
# be sure to have in your path the commands: 
#    xdialog (HP-UX), or 
#    xmessage (SunOS,Linux,OSF1)
#-------------------------------------------------------------------------
my_proc=uves_stability.prg
my_script=uves_stability.sh
export my_proc
export my_script
my_test=stability
my_cat=stability.cat
export my_test
export my_cat
if [ -z "$PIPE_HOME" ]; then
    if [ -z "$MIDASHOME" ]; then
       echo 'Environment variable MIDASHOME is not defined. Abort!'
       exit
    fi
    if [ -z "$MIDVERS" ]; then
       echo 'Environment variable MIDVERS is not defined. Abort!'
       exit
    fi
    echo 'Environment variable PIPE_HOME is not defined. '
    echo 'Setting it to '${MIDASHOME}'/'${MIDVERS}'/pipeline.'
    PIPE_HOME=${MIDASHOME}/${MIDVERS}/pipeline
    export PIPE_HOME
    echo ${PIPE_HOME}
fi 

script_dir=$PIPE_HOME/uves/uves/scripts
#common part to do some checks and settings
. $script_dir/uves_common.sh
 
#MIDAS opening procedure
. $script_dir/uves_midas_pre.sh
 
 
 
#MIDAS specific procedure
printf 'SPLIT/UVES stability.cat \n \
        @p uves_stability split.cat \n \
    write/out " " \n \
    write/out "To exit MIDAS session type  bye" \n \
' >> ${wrk}/${my_proc}
 

# Start the MIDAS session
. $script_dir/uves_midas_start.sh
 
exit
 
 
 
 
 
 
